Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| Java™ Platform Standard Ed. 6
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## java.security
Class AlgorithmParameters

    java.lang.Object
      java.security.AlgorithmParameters

    public class AlgorithmParameters

extends Object

This class is used as an opaque representation of cryptographic parameters.

An `AlgorithmParameters` object for managing the parameters for a particular algorithm can be obtained by calling one of the `getInstance` factory methods (static methods that return instances of a given class).

Once an `AlgorithmParameters` object is obtained, it must be initialized via a call to `init`, using an appropriate parameter specification or parameter encoding.

A transparent parameter specification is obtained from an `AlgorithmParameters` object via a call to `getParameterSpec`, and a byte encoding of the parameters is obtained via a call to `getEncoded`.

Since:
  1.2
See Also:
  `AlgorithmParameterSpec`, `DSAParameterSpec`, `KeyPairGenerator`

Constructor Summary
`protected` | `AlgorithmParameters(AlgorithmParametersSpi paramSpi, Provider provider, String algorithm)` Creates an AlgorithmParameters object.

Method Summary
`String` | `getAlgorithm()` Returns the name of the algorithm associated with this parameter object.
`byte[]` | `getEncoded()` Returns the parameters in their primary encoding format.
`byte[]` | `getEncoded(String format)` Returns the parameters encoded in the specified scheme.
`static AlgorithmParameters` | `getInstance(String algorithm)` Returns a parameter object for the specified algorithm.
`static AlgorithmParameters` | `getInstance(String algorithm, Provider provider)` Returns a parameter object for the specified algorithm.
`static AlgorithmParameters` | `getInstance(String algorithm, String provider)` Returns a parameter object for the specified algorithm.
`
`<T extends AlgorithmParameterSpec> T`
` | `getParameterSpec(Class<T> paramSpec)` Returns a (transparent) specification of this parameter object.
`Provider` | `getProvider()` Returns the provider of this parameter object.
`void` | `init(AlgorithmParameterSpec paramSpec)` Initializes this parameter object using the parameters specified in `paramSpec`.
`void` | `init(byte[] params)` Imports the specified parameters and decodes them according to the primary decoding format for parameters.
`void` | `init(byte[] params, String format)` Imports the parameters from `params` and decodes them according to the specified decoding scheme.
`String` | `toString()` Returns a formatted string describing the parameters.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Constructor Detail

### AlgorithmParameters

    protected AlgorithmParameters(AlgorithmParametersSpi paramSpi,
                                  Provider provider,
                                  String algorithm)

  Creates an AlgorithmParameters object.

  Parameters:
    `paramSpi` - the delegate
    `provider` - the provider
    `algorithm` - the algorithm

Method Detail

### getAlgorithm

    public final String getAlgorithm()

  Returns the name of the algorithm associated with this parameter object.

  Returns:
    the algorithm name.

### getInstance

    public static AlgorithmParameters getInstance(String algorithm)
                                           throws NoSuchAlgorithmException

  Returns a parameter object for the specified algorithm.

  This method traverses the list of registered security Providers, starting with the most preferred Provider. A new AlgorithmParameters object encapsulating the AlgorithmParametersSpi implementation from the first Provider that supports the specified algorithm is returned.

  Note that the list of registered providers may be retrieved via the `Security.getProviders()` method.

  The returned parameter object must be initialized via a call to `init`, using an appropriate parameter specification or parameter encoding.

  Parameters:
    `algorithm` - the name of the algorithm requested. See Appendix A in the Java Cryptography Architecture API Specification & Reference for information about standard algorithm names.
  Returns:
    the new parameter object.
  Throws:
    `NoSuchAlgorithmException` - if no Provider supports an AlgorithmParametersSpi implementation for the specified algorithm.
  See Also:
    `Provider`

### getInstance

    public static AlgorithmParameters getInstance(String algorithm,
                                                  String provider)
                                           throws NoSuchAlgorithmException,
                                                  NoSuchProviderException

  Returns a parameter object for the specified algorithm.

  A new AlgorithmParameters object encapsulating the AlgorithmParametersSpi implementation from the specified provider is returned. The specified provider must be registered in the security provider list.

  Note that the list of registered providers may be retrieved via the `Security.getProviders()` method.

  The returned parameter object must be initialized via a call to `init`, using an appropriate parameter specification or parameter encoding.

  Parameters:
    `algorithm` - the name of the algorithm requested. See Appendix A in the Java Cryptography Architecture API Specification & Reference for information about standard algorithm names.
    `provider` - the name of the provider.
  Returns:
    the new parameter object.
  Throws:
    `NoSuchAlgorithmException` - if an AlgorithmParametersSpi implementation for the specified algorithm is not available from the specified provider.
    `NoSuchProviderException` - if the specified provider is not registered in the security provider list.
    `IllegalArgumentException` - if the provider name is null or empty.
  See Also:
    `Provider`

### getInstance

    public static AlgorithmParameters getInstance(String algorithm,
                                                  Provider provider)
                                           throws NoSuchAlgorithmException

  Returns a parameter object for the specified algorithm.

  A new AlgorithmParameters object encapsulating the AlgorithmParametersSpi implementation from the specified Provider object is returned. Note that the specified Provider object does not have to be registered in the provider list.

  The returned parameter object must be initialized via a call to `init`, using an appropriate parameter specification or parameter encoding.

  Parameters:
    `algorithm` - the name of the algorithm requested. See Appendix A in the Java Cryptography Architecture API Specification & Reference for information about standard algorithm names.
    `provider` - the name of the provider.
  Returns:
    the new parameter object.
  Throws:
    `NoSuchAlgorithmException` - if an AlgorithmParameterGeneratorSpi implementation for the specified algorithm is not available from the specified Provider object.
    `IllegalArgumentException` - if the provider is null.
  Since:
    1.4
  See Also:
    `Provider`

### getProvider

    public final Provider getProvider()

  Returns the provider of this parameter object.

  Returns:
    the provider of this parameter object

### init

    public final void init(AlgorithmParameterSpec paramSpec)
                    throws InvalidParameterSpecException

  Initializes this parameter object using the parameters specified in `paramSpec`.

  Parameters:
    `paramSpec` - the parameter specification.
  Throws:
    `InvalidParameterSpecException` - if the given parameter specification is inappropriate for the initialization of this parameter object, or if this parameter object has already been initialized.

### init

    public final void init(byte[] params)
                    throws IOException

  Imports the specified parameters and decodes them according to the primary decoding format for parameters. The primary decoding format for parameters is ASN.1, if an ASN.1 specification for this type of parameters exists.

  Parameters:
    `params` - the encoded parameters.
  Throws:
    `IOException` - on decoding errors, or if this parameter object has already been initialized.

### init

    public final void init(byte[] params,
                           String format)
                    throws IOException

  Imports the parameters from `params` and decodes them according to the specified decoding scheme. If `format` is null, the primary decoding format for parameters is used. The primary decoding format is ASN.1, if an ASN.1 specification for these parameters exists.

  Parameters:
    `params` - the encoded parameters.
    `format` - the name of the decoding scheme.
  Throws:
    `IOException` - on decoding errors, or if this parameter object has already been initialized.

### getParameterSpec

    public final <T extends AlgorithmParameterSpec> T getParameterSpec(Class<T> paramSpec)
                                                            throws InvalidParameterSpecException

  Returns a (transparent) specification of this parameter object. `paramSpec` identifies the specification class in which the parameters should be returned. It could, for example, be `DSAParameterSpec.class`, to indicate that the parameters should be returned in an instance of the `DSAParameterSpec` class.

  Parameters:
    `paramSpec` - the specification class in which the parameters should be returned.
  Returns:
    the parameter specification.
  Throws:
    `InvalidParameterSpecException` - if the requested parameter specification is inappropriate for this parameter object, or if this parameter object has not been initialized.

### getEncoded

    public final byte[] getEncoded()
                            throws IOException

  Returns the parameters in their primary encoding format. The primary encoding format for parameters is ASN.1, if an ASN.1 specification for this type of parameters exists.

  Returns:
    the parameters encoded using their primary encoding format.
  Throws:
    `IOException` - on encoding errors, or if this parameter object has not been initialized.

### getEncoded

    public final byte[] getEncoded(String format)
                            throws IOException

  Returns the parameters encoded in the specified scheme. If `format` is null, the primary encoding format for parameters is used. The primary encoding format is ASN.1, if an ASN.1 specification for these parameters exists.

  Parameters:
    `format` - the name of the encoding format.
  Returns:
    the parameters encoded using the specified encoding scheme.
  Throws:
    `IOException` - on encoding errors, or if this parameter object has not been initialized.

### toString

    public final String toString()

  Returns a formatted string describing the parameters.

  Overrides:
    `toString` in class `Object`
  Returns:
    a formatted string describing the parameters, or null if this parameter object has not been initialized.

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| Java™ Platform Standard Ed. 6
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Submit a bug or feature
For further API reference and developer documentation, see Java SE Developer Documentation. That documentation contains more detailed, developer-targeted descriptions, with conceptual overviews, definitions of terms, workarounds, and working code examples.

Copyright 2009 Sun Microsystems, Inc. All rights reserved. Use is subject to license terms. Also see the documentation redistribution policy.